define(["require", "exports", 'MindFusion.Charting'], function (require, exports, m) {
    "use strict";
    var Charting = m.MindFusion.Charting;
    var Controls = m.MindFusion.Charting.Controls;
    var Collections = m.MindFusion.Charting.Collections;
    var Drawing = m.MindFusion.Charting.Drawing;

	//create the chart
	var funnelChartEl = document.getElementById('funnelChart');
	
	var funnelChart = new Controls.FunnelChart(funnelChartEl);
	
	//initialize data and labels
	var data = new Collections.List([100, 90, 80, 37, 17, 7]);
	var labels = new Collections.List(["Elementary school", "Middle School", "High school", "Bachelor", "Master", "Doc"]);
	
	//assign a series
	funnelChart.series = new Charting.SimpleSeries(data, labels);
	
	funnelChart.title = "Education Enrollment";
	funnelChart.showLegend = false;
	
	var brushes = new Collections.List([
	
	    new Drawing.Brush("#193e4e"),
        new Drawing.Brush("#5a7444"),
        new Drawing.Brush("#8eb848"),
        new Drawing.Brush("#678b99"),
        new Drawing.Brush("#a1d0d8"),
        new Drawing.Brush("#c5b28a"),
		
	]);
	
	var seriesBrushes = new Collections.List();
	seriesBrushes.add(brushes);
	
	var strokes = new Collections.List([
	
	    new Drawing.Brush("#f2ebcf"),
        		
	]);
	
	var seriesStrokes = new Collections.List();
	seriesStrokes.add(strokes);
	
	var strokeThicknesses = new Collections.List([
	
	    10,
        		
	]);
	
	var serieStrokeThicknesses = new Collections.List();
	serieStrokeThicknesses.add(strokeThicknesses);
	
	funnelChart.plot.seriesStyle = new Charting.PerElementSeriesStyle(seriesBrushes, seriesStrokes, serieStrokeThicknesses);	
	
	funnelChart.theme.titleFontSize = 18;
	funnelChart.theme.titleFontName = "Roboto";
	funnelChart.theme.titleFontStyle = Drawing.FontStyle.Bold;
	
	funnelChart.theme.dataLabelsFontName = "Roboto";
	funnelChart.theme.dataLabelsFontSize = 14;
	
	funnelChart.theme.highlightStroke = new Drawing.Brush("#ffcc33");
	
	funnelChart.margin = new Charting.Margins(0, 10, 0, 0);
	
	var tooltips = new Collections.List(["32.7%", "29.5%", "26.2%", "12%", "5%", "2%"]);
	funnelChart.series.tooltips = tooltips;
	
	Object.defineProperty(m.MindFusion.Charting.SimpleSeries.prototype, "supportedLabels", {
            get: function () { return m.MindFusion.Charting.LabelKinds.InnerLabel | m.MindFusion.Charting.LabelKinds.ToolTip; },
            enumerable: true,
            configurable: true
        });
		
		m.MindFusion.Charting.SimpleSeries.prototype.getLabel = function (index, kind) {
		if ((kind & m.MindFusion.Charting.LabelKinds.ToolTip) != 0 && this.tooltips)
			return this.tooltips.items()[index];
		
		if (this.labels == null)
			return null;
		return this.labels.items()[index];
	};

	
	
	funnelChart.draw();
});